//---------------------------------------------------------------------------

#ifndef FormMainH
#define FormMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>

#include "Settings.h"
#include <Menus.hpp>
#include <ActnList.hpp>
#include <ImgList.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <StdActns.hpp>
#include <Buttons.hpp>

class TrayIcon;
class TfrmButtonContainer;

//---------------------------------------------------------------------------
class TfrmMain : public TForm
{
__published:	// IDE-managed Components
	TStatusBar *StatusBar;
	TPanel *pnlSpeedDial;
	TPanel *pnlMain;
	TLabel *lblCallState;
	TLabel *lbl2ndParty;
	TSpeedButton *btnBackspace;
	TButton *btnMakeCall;
	TButton *btnHangup;
	TComboBox *cbCallURI;
	TPageControl *pcMain;
	TTabSheet *tsDialpad;
	TButton *btnDial1;
	TButton *btnDial2;
	TButton *btnDial3;
	TButton *btnDial4;
	TButton *btnDial5;
	TButton *btnDial6;
	TButton *btnDial7;
	TButton *btnDial8;
	TButton *btnDial9;
	TButton *btnDialStar;
	TButton *btnDial0;
	TButton *btnDialHash;
	TEdit *edTransfer;
	TTabSheet *tsHistory;
	TMainMenu *MainMenu;
	TMenuItem *miFile;
	TMenuItem *miExit;
	TMenuItem *miView;
	TMenuItem *miViewLog;
	TMenuItem *miSettings;
	TMenuItem *miCommonSettings;
	TMenuItem *miHelp;
	TMenuItem *miAbout;
	TActionList *ActionList;
	TAction *actShowAbout;
	TAction *actShowSettings;
	TAction *actShowLog;
	TFileExit *actFileExit;
	TImageList *imglistActions;
	TTimer *tmrStartup;
	TTimer *tmrCallbackPoll;
	TButton *btnSpeedDialPanel;
	TTimer *tmrBackspace;
	TTabSheet *tsContacts;
	TLabel *lbl2ndPartyDesc;
	TMenuItem *miMinimizeTray;
	TPopupMenu *popupTray;
	TMenuItem *miTrayExit;
	TAction *actExit;
	TTimer *tmrAutoAnswer;
	TImageList *imgListButtons;
	TPanel *pnlButtonsBasic;
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall actShowAboutExecute(TObject *Sender);
	void __fastcall actShowSettingsExecute(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall actShowLogExecute(TObject *Sender);
	void __fastcall tmrStartupTimer(TObject *Sender);
	void __fastcall btnMakeCallClick(TObject *Sender);
	void __fastcall btnHangupClick(TObject *Sender);
	void __fastcall tmrCallbackPollTimer(TObject *Sender);
	void __fastcall btnDialClick(TObject *Sender);
	void __fastcall btnBackspaceClick(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall btnAutoAnswerClick(TObject *Sender);
	void __fastcall edTransferEnter(TObject *Sender);
	void __fastcall btnSpeedDialPanelClick(TObject *Sender);
	void __fastcall cbCallURIKeyPress(TObject *Sender, char &Key);
	void __fastcall btnBackspaceMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall btnBackspaceMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall tmrBackspaceTimer(TObject *Sender);
	void __fastcall miMinimizeTrayClick(TObject *Sender);
	void __fastcall actExitExecute(TObject *Sender);
	void __fastcall tmrAutoAnswerTimer(TObject *Sender);
	void __fastcall edTransferKeyPress(TObject *Sender, char &Key);
private:	// User declarations
	TrayIcon *trIcon;
	TfrmButtonContainer *frmButtonContainerBasic;
	TfrmButtonContainer *frmButtonContainerExt;
	TfrmButtonContainer *frmButtonContainerExt2;
	struct Call {
		bool incoming;
		bool progress;	// early media
		bool connected;
		AnsiString uri;
		TDateTime timestamp;
		Call(void):
			incoming(false),
			progress(false),
			connected(false)
		{}
	} call;
	void SetSpeedDial(bool visible);
	void UpdateCallHistory(void);
	AnsiString CleanUri(AnsiString uri);
	void MakeCall(AnsiString target);
	void CallNumberBackspace(void);
	void Hangup(void);
	int autoAnswerCode;
	bool autoAnswerIntercom;
	void AutoAnswer(void);
	void Redial(void);
	void Dial(char digit);
	void UpdateHoldState(bool state);

	void SetStatus(AnsiString text);
	void __fastcall OnTrayIconLeftBtnDown(TObject *Sender);
	void __fastcall OnTrayIconRightBtnDown(TObject *Sender);	
public:		// User declarations
	__fastcall TfrmMain(TComponent* Owner);
	__fastcall ~TfrmMain();
	void OnCall(AnsiString uri);
	void OnProgrammableBtnClick(int id, bool down);
};
//---------------------------------------------------------------------------
extern PACKAGE TfrmMain *frmMain;
//---------------------------------------------------------------------------
#endif
